/** \file
*/

/*
* ----------------------------------------------------------------------------
* "THE BEER-WARE LICENSE":
* tomasz.o.ostrowski <that funny sign> gmail.com wrote this file.
* As long as you retain this notice you can do whatever you want with
* this stuff. If we meet some day, and you thinkthis stuff is worth it,
* you can buy me a beer in return
* Tomasz Ostrowski
* ----------------------------------------------------------------------------
*/

#include <vcl.h>
#pragma hdrstop

#include "DrawThread.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
__fastcall DrawThread::DrawThread(bool CreateSuspended, int ic )
                        :TThread(CreateSuspended)
{
   count = ic;
}

__fastcall DrawThread::~DrawThread()
{
}

void DrawThread::Process( TPaintBox* in, int iZeroL, int iZeroR, short* idata )
{
   view=in;
   data=idata;
   leftzerolevel=iZeroL;
   rightzerolevel=iZeroR;
   Resume();
}

//---------------------------------------------------------------------------
void __fastcall DrawThread::Execute()
{
   while ( !Terminated )
   {
      FillBuffer();
   }
}

void __fastcall DrawThread::FillBuffer()
{
   double timescale = view->ClientHeight/32768.0;    ///< scale for Y-axis, 16 bit signed data

   view->Canvas->Lock();
   view->Canvas->Brush->Color = clBlack;
   view->Canvas->Pen->Color = clWhite;
   view->Canvas->Rectangle( 0, 0, view->ClientWidth, view->ClientHeight );
   double ts = static_cast<double>(view->ClientWidth)/static_cast<double>(count);   ///< scale for X-axis
   int x;
   // paint left channel
   view->Canvas->MoveTo(0, leftzerolevel);
   view->Canvas->Pen->Color = clBlue;
   for(int i=0; i<count-1; i+=2)
   {
	   x=i*ts;
	   int y = leftzerolevel - static_cast<double>(data[i])*timescale;
	   view->Canvas->LineTo( x ,y );
   }
   // paint right channel
   view->Canvas->MoveTo(0, rightzerolevel);
   view->Canvas->Pen->Color = clGreen;
   for(int i=1; i<count; i+=2)
   {
       x=i*ts;
       int y = rightzerolevel - static_cast<double>(data[i])*timescale;
       view->Canvas->LineTo( x ,y );
   }
   view->Canvas->Unlock();
   Suspend();
}
//---------------------------------------------------------------------------
